package qr.object;

import java.io.File;
import java.util.ArrayList;

import jsyn.unit.circuit.Sampler;
import processing.core.PApplet;
import qr.Qr;
import qr.synth.Mixer;
import qr.synth.Quantized;
import qr.synth.Sequencer;
import qr.synth.SequencerTask;

import com.softsynth.jsyn.LinearLag;
import com.softsynth.jsyn.PanUnit;
import com.softsynth.jsyn.SynthOutput;

public class Word implements Quantized{
	Qr qr;
	protected int color;
	protected int[][] colors = { { 255, 0, 0 }, { 255, 128, 0 },
		{ 128, 128, 0 }, { 0, 255, 0 }, { 0, 128, 0 },
		{ 0, 0, 255 }, { 0, 0, 128 }, { 128, 0, 128 }, };
	private char key;
//	float x, y;
	private float ix, iy;
	protected float rx, ry, rz;
	private float speed;
	private float rad, trad, drad;
	private int cntr, counter, deathCounter;
	private int thisportnum;
	private String word;
	protected float alphath;
	protected float alphain = 1f;
	protected boolean deletebl = false;
	protected File samplePath;
	private float default_amp = 0.8f;
	protected Sampler sampler;
	protected PanUnit panUnit;
	protected LinearLag pan;
	protected ArrayList wakes;
	private boolean stoprot = false;
	protected transient SynthOutput lineOut;// TEho
	protected int seqLength = 32;			// V[PT̃Xebv
	protected int seqPos = 0;				// V[PŤ݈ʒu
	private int useMixerPort;				// ̃IuWFNggĂMixer̃|[gԍ
	protected boolean[] seq = new boolean[seqLength];				// V[PTEf[^
	private int flag;
	private int pm;

	
	public Word(Qr qr, String swf, String word, int mobnum, int sendmob){
		this.qr = qr;
		for(int i = 0; i < seqLength; i++){
			seq[i] = false;
		}
		this.samplePath = new File("wav/" + swf + ".wav");
		wakes = new ArrayList();
		identifyWord(swf, word);
		initpos(swf, mobnum, sendmob);
		synth();
		flag = 0;
	}
	
	public Word(Qr qr, float x, float y){
		this.qr = qr;
		this.ix = x;
		this.iy = y;
		flag = 3;
	}
	
	protected void initpos(String swf, int mobnum, int sendmob){
		int swfn = (int)swf.charAt(0) - 48;
		int swfm = (int)swf.charAt(2) - 48;
		ix = ((((swfn + swfm + sendmob)%10) * 10 + sendmob * 2)* 0.008f - 0.4f)*qr.width;
		iy = ((((mobnum + (swfm * 2) + sendmob)%10) * 10 + swfm) * 0.008f - 0.4f)*qr.height;
		pm = (swfm + mobnum) % 2;
		rad = 0;
		trad = 0;
		drad = 0;
		counter = 0;
		float xx = ix + qr.width * 0.5f;
		float yy = iy + qr.height * 0.5f;
		speed = ((swfn + swfm) % 8) * 0.000625f + 0.01f;
		rx = xx;
		ry = yy;
	}
	
	private void identifyWord(String swf, String word){
		this.word = word;
		this.color = (int)swf.charAt(2) - 48;
	}
	
	public void draw(){
		int fontSize = qr.getMiddleFontSize();
		switch(flag){
		case 0:
			float xx = ix + (qr.width * 0.5f);
			float yy = iy + (qr.height * 0.5f);
			counter++;
			if(counter > 180){
				counter = 180;
			}
			qr.pushMatrix();
			qr.translate(xx, yy);
			qr.noStroke();
			qr.fill(colors[color][0], colors[color][1], colors[color][2], counter);
			qr.translate(fontSize * 0.25f, 0);
			if(pm == 1)
				qr.rotateY(PApplet.radians(drad += 19 - counter * 0.05f));
			else
				qr.rotateY(PApplet.radians(drad -= 19 - counter * 0.05f));
			qr.translate(-fontSize * 0.25f, 0);
			qr.textFont(qr.getMiddleFont(), fontSize);
			qr.text(word, -qr.textWidth(word) * 0.3f, 0);
			qr.popMatrix();
			if(drad > 360 || drad < -360){
				drad = 0;
			}
			break;
		case 1:
			qr.pushMatrix();
			qr.translate(qr.width * 0.5f, qr.height * 0.5f);
//			qr.line(0, -qr.height * 0.5f, 10, qr.height * 0.5f);
			if(pm == 1){
				qr.rotateY(rad += speed);
//				qr.rotateY(PApplet.radians(rad += speed));
			}else{
				qr.rotateY(rad -= speed);
//				qr.rotateY(PApplet.radians(rad -= speed));
			}
			qr.translate(ix, iy);
			qr.noStroke();
			qr.fill(colors[color][0], colors[color][1], colors[color][2], 180);
//			qr.setMiddleFont();
			if(!stoprot){
				qr.translate(fontSize * 0.25f, 0);
				if(pm == 1)
					qr.rotateY(PApplet.radians(drad += 19 - counter * 0.05f));
				else
					qr.rotateY(PApplet.radians(drad -= 19 - counter * 0.05f));
				qr.translate(-fontSize * 0.25f, 0);
			}
			qr.textFont(qr.getMiddleFont(), fontSize);
			qr.text(word, -qr.textWidth(word) * 0.3f, 0);
			qr.popMatrix();
			if(rad > Math.PI * 2 || rad < - Math.PI * 2){
				rad = 0;
			}
			if(drad > 360 || drad < - 360){
				stoprot =true;
			}
			for(int i = 0; i < wakes.size(); i++) {
				if(!((Wake)wakes.get(i)).draw(qr)) {	//g`
					wakes.remove(i);
				}
			}
			break;
		case 2:
			qr.pushMatrix();
			qr.translate(qr.width * 0.5f, qr.height * 0.5f);
//			qr.line(0, -qr.height * 0.5f, 10, qr.height * 0.5f);
			if(pm == 1){
				qr.rotateY(rad += speed);
//				qr.rotateY(PApplet.radians(rad += speed));
			}else{
				qr.rotateY(rad -= speed);
//				qr.rotateY(PApplet.radians(rad -= speed));
			}
			qr.translate(ix, iy);
			qr.noStroke();
			qr.fill(colors[color][0], colors[color][1], colors[color][2], 180 - deathCounter);
//			qr.setMiddleFont();
			if(!stoprot){
				qr.translate(fontSize * 0.25f, 0);
				if(pm == 1)
					qr.rotateY(PApplet.radians(drad += 19 - counter * 0.05f));
				else
					qr.rotateY(PApplet.radians(drad -= 19 - counter * 0.05f));
				qr.translate(-fontSize * 0.25f, 0);
			}
			qr.textFont(qr.getMiddleFont(), fontSize);
			qr.text(word, -qr.textWidth(word) * 0.3f, 0);
			qr.popMatrix();
			if(rad > Math.PI * 2 || rad < - Math.PI * 2){
				rad = 0;
			}
			if(drad > 360 || drad < - 360){
				stoprot =true;
			}
			for(int i = 0; i < wakes.size(); i++) {
				if(!((Wake)wakes.get(i)).draw(qr)) {	//g`
					wakes.remove(i);
				}
			}
			sampler.setAmp(default_amp - (float)((deathCounter)/ 180.0f));
			deathCounter++;
			if(180 - deathCounter == 0){
				destroy();
				Qr.deleteWord(this);
			}
			break;
		case 3:
			qr.pushMatrix();
			qr.translate(ix, iy);
			qr.noStroke();
			qr.fill(255, 255, 255, 180);
			qr.textFont(qr.getMiddleFont(), fontSize);
			qr.translate(0, - fontSize * 0.25f);
			qr.rotateX(PApplet.radians(-trad));
			qr.translate(0, fontSize * 0.25f);
			qr.text(key, - fontSize * 0.5f, 0);
			qr.popMatrix();
			break;
		}
		
		radToPos(rad);
	}
	
	public void setTrad(int trad){
		this.trad = trad;
	}
	
	public void setKey(int key){
		this.key = (char)key;
	}
	
	private void radToPos(float rad){ // ̍Wɕϊ
		rx = (float)(ix * Math.cos(rad));
		rz = - (float)(ix * Math.sin(rad));
		rx = rx + qr.width * 0.5f;
		ry = iy + qr.height * 0.5f;
	}
	
	protected float getrx(){ // ̍Wnł̈ʒuFX
		return rx;
	}
	
	protected float getry(){ // ̍Wnł̈ʒuFY
		return ry;
	}
	
	protected float getrz(){ // ̍Wnł̈ʒuFZ
		return rz;
	}
	
	class Wake {
		int life;
		float wx, wy, wz, ws;
		private int counter = 0;
		
		Wake() {
			this(40, 20);
		}
		
		Wake(int life, int size) {
			this.life = life;
			this.ws = size;
			initPos();
		}
		
		boolean draw(Qr qr) {
			float alpha = alphain - alphath*2f;
			if(alphain - alphath < 0)
				alpha = 0;
			
			counter++;
			qr.pushMatrix();
			qr.translate(wx + qr.getMiddleFontSize()* 0.5f, wy - qr.getMiddleFontSize() * 0.5f, wz);
			qr.rectMode(Qr.CENTER);
			qr.rotateZ(counter);
			qr.fill(colors[color][0], colors[color][1], colors[color][2], alpha*100 - (counter + 10) * 2);
			qr.box(qr.getMiddleFontSize() * 0.5f);
			qr.stroke(colors[color][0], colors[color][1], colors[color][2], alpha*240 - (counter + 10) * 2);
			qr.noFill();
			qr.rect(0, 0, /*qr.textWidth(word)+*/ws + counter*4f, ws+counter*4f);
			if(counter > 5){
				qr.rotateZ(- counter * 2);
				qr.stroke(colors[color][0], colors[color][1], colors[color][2], alpha*240 - (counter) * 2);
				qr.rect(0, 0, /*qr.textWidth(word)+*/ws + (counter - 10)*4f, ws+(counter - 10)*4f);
			}
			qr.popMatrix();
			if(counter > life) {
				return false;
			}
			return true;
		}
		
		void initPos(){
			wx = rx;
			wy = ry;
			wz = rz;
		}
	}

	protected void synth() {
		// ftHg̃VZdl
		sampler = new Sampler(samplePath);			// SamplerCX^X
		sampler.setAmp(default_amp);					// Sampler̃QCݒ

		panUnit = new PanUnit();
		panUnit.start();
		
		pan = new LinearLag();
		pan.time.set(10.0/SequencerTask.bpm);
		pan.input.set(0.5);
		pan.start();
		
		sampler.output.connect(panUnit.input);			// T[Lbg̐ڑ
		pan.output.connect(panUnit.pan);
		
		lineOut = panUnit.output;					// o͂tB^[̏o͂ɐݒ
		thisportnum = lineOut.getNumParts();
		seq[8] = true;
	}
	
	public final void beat(int now, int duration, int beatIndex) {
		/* ʂ */
		pan.input.set(((float)(rx / (float)qr.width)*2)-1);
		sampler.setAmp((float)(rz / (float)qr.width) * 0.2 + 0.8f);
		
		if(seq[seqPos++ % seqLength]){
			if(flag == 0){
				flag = 1;
				rad = 0;
			}
			note(now, duration);
		}
	}
	
	protected void note(int now, int duration){
		cntr++;
		
		if(cntr > qr.getLIFE_NUM() - 1){
			flag = 2;
		}
		
		sampler.play(); // ̃gK
		//	}
		if(wakes.size() < 2)
			wakes.add(new Wake(60, 30));
	}
	
	public final int getUseMixerPort() {
		return useMixerPort;
	}
	
	public void setLocation(float ix, float iy){
		this.ix = ix;
		this.iy = iy;
	}
	
	/* ( Javadoc)
	 * @see pcode.object.CObjectControl#destroy()
	 */
	public final void destroy() {
		System.out.println("useMixerPort: " + useMixerPort);
		System.out.println("lineOut: " + lineOut);
		
		Mixer.disconnectOutputFromMixer(useMixerPort, thisportnum);
		Sequencer.remove(this);
		lineOut.disconnect();
		lineOut = null;
	}
	
	public final void setUseMixerPort(int usePort) {
		useMixerPort = usePort;
	}
	
	public SynthOutput getLineout() {
		return lineOut;
	}

}
