package qr.synth;

import java.util.TimerTask;
import com.softsynth.jsyn.Synth;
import com.softsynth.jsyn.SynthException;

public class SequencerTask extends TimerTask{
	private Sequencer seq;
	public static int bpm = 24;
	private static int notesPerBeat = 4;
	public static int duration = (int)(Synth.getTickRate() * (60.0/bpm)) / notesPerBeat;
	private int beatIndex;
	private int advance;
	private int now;
	
	public SequencerTask(Sequencer seq){
		System.out.println("run() - begin Sequence = " + Thread.currentThread() );
		this.seq = seq;
		duration = (int)(Synth.getTickRate() * (60.0/bpm)) / notesPerBeat;
		beatIndex = 0;
		advance = (int) (Synth.getTickRate() * 0.05);
		now = Synth.getTickCount();
	}
	
	public void run(){
		try
		{
			seq.beat(now  + advance, duration, beatIndex);
			now += duration;
			beatIndex++;
			Synth.sleepUntilTick( now );
		} catch (SynthException e) {
			System.out.println("run caught " + e );
		}
//		System.out.println("run() - end currentThread = " + Thread.currentThread() );
	}

	public static void updateSequencer(int bpm, int notes) {
		SequencerTask.bpm = bpm;
		notesPerBeat = notes;
		duration = (int)(Synth.getTickRate() * (60.0/bpm)) / notesPerBeat;
	}

}
