package qrcode;

import processing.core.PApplet;


public class Pixs{
	QrCode qc;
	int state;
	int COL, ROW, cellSize;
	private boolean[][] box;
	static final int RUN0 = 0;
	static final int RUN1 = 1;
	static final int RUN2 = 2;
	static final int RUN3 = 3;
	static final int RUN4 = 4;
	static final int FIN0 = 10;
	static final int FIN1 = 11;
	static final int FIN2 = 12;
	static final int FIN3 = 13;
	static final int FIN4 = 14;
	static final int IDLE = 100;
	private int qrratio;
	int distant;
	int counter = 0;
	int imgno;
	private int MODE = 0;
	private boolean firstf = true;
	boolean run = false;
	
	public Pixs(QrCode qc,int imgno, int COL, int ROW, int cellSize){
		this.qc = qc;
		this.COL = COL;
		this.ROW = ROW;
		this.cellSize = cellSize;
		this.imgno = imgno;
		init();
	}
	
	
	public void init(){
		qrratio = (int)((qc.width / 1024.0f) * 12);
		box = new boolean[cellSize][cellSize];
		
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				int x = COL * cellSize + i;
				int y = ROW * cellSize + j;
				int c = QrCode.img[imgno].get(x, y);
				
				int brue = c & 255;
				if(brue == 0){
					box[i][j] = true;
				}else{
					box[i][j] = false;
				}
			}
		}
		distant = qc.height/3 + (int)(Math.random() * qc.height);
	}
	
	public void draw(){
		changeRatioListener(qrratio);
		switch(MODE){
		case RUN0:
			draw0();
			break;
		case RUN1:
			draw1();
			break;
		case RUN2:
			draw2();
			break;
		case RUN3:
			draw3();
			break;
		case RUN4:
			draw4();
			break;
		case FIN0:
			if(firstf){
				counter = qc.width * 5;
				firstf = false;
				run = false;
			}
			findraw0();
			break;
		case FIN1:
			if(firstf){
				counter = 180;
				firstf = false;
				run = false;
			}
			findraw1();
			break;
		case FIN2:
			if(firstf){
				counter = qc.width * 5;
				firstf = false;
				run = false;
			}
			findraw2();
			break;
		case FIN3:
			if(firstf){
				counter = - 180;
				firstf = false;
				run = false;
			}
			findraw3();
			break;
		case FIN4:
			if(firstf){
				counter = - 180;
				firstf = false;
				run = false;
			}
			findraw4();
			break;
		case IDLE:
			break;
		}
	}
	
	private void draw0(){
		int buff = (int)(((float)counter / (float)(qc.width * 5)) * 100);
		float z = ((float)(qc.width * 5 - counter) / ((float) qc.width * 2)) * distant;
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(box[i][j]){
					qc.pushMatrix();
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate((qc.width * 0.5f) - (QrCode.img[imgno].width * qrratio * 0.5f) + x, (qc.height * 0.5f) - (QrCode.img[imgno].height * qrratio * 0.5f) + y, z);
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2], buff);
					qc.rectMode(QrCode.CENTER);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(qc.width * 5 - counter != 0)
							qc.box(qrratio, qrratio, qrratio * 6 * z / (qc.width * 5 - counter));
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix(); 
				}
			}
		}
		counter+= 50;
		if(counter > qc.width * 5){
			counter = qc.width * 5;
			if(!run){
				run = true;
				firstf = true; // Ȉ
				qc.setRUNFIN(true);
			}
		}
	}
	
	private void draw1(){
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(counter > 90 &&box[i][j]){
					qc.pushMatrix();
					qc.translate(qc.width*0.5f, qc.height*0.5f);
					qc.rotateX(PApplet.radians(counter));
					qc.rotateY(PApplet.radians(counter));
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate((QrCode.img[imgno].width * qrratio * 0.5f) - x, (QrCode.img[imgno].height * qrratio * 0.5f) - y);
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2], counter - 80);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(counter != 0)
							qc.box(qrratio, qrratio, qrratio * 2 * counter / 180.0f);
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix();
				}
			}
		}
		counter += 4;
		if(counter > 180){
			counter = 180;
			if(!run){
				run = true;
				firstf = true; // Ȉ
				qc.setRUNFIN(true);
			}
		}
	}
	
	private void draw2(){
		int buff = (int)(((float)counter / (float)(qc.width * 5)) * 100);
		float z = ((float)(qc.width * 5 - counter) / ((float) qc.width * 2)) * distant;
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(box[i][j]){
					qc.pushMatrix();
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate((qc.width * 0.5f) - (QrCode.img[imgno].width * qrratio * 0.5f) + x + z * (COL % 2 * 2 - 1), (qc.height * 0.5f) - (QrCode.img[imgno].height * qrratio * 0.5f) + y + z * (ROW % 2 * 2 - 1));
					qc.fill(0, buff);
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2], buff);
					qc.rectMode(QrCode.CENTER);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(qc.width * 5 - counter != 0)
							qc.box(qrratio, qrratio, qrratio * z / (qc.width * 5 - counter));
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix();
				}
			}
		}
		counter+= 50;
		if(counter > qc.width * 5){
			counter = qc.width * 5;
			if(!run){
				run = true;
				firstf = true; // Ȉ
				qc.setRUNFIN(true);
			}
		}
	}
	
	private void draw3(){
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(box[i][j] && counter > 90){
					qc.pushMatrix();
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate((qc.width * 0.5f) - (QrCode.img[imgno].width * qrratio * 0.5f) + x,
							(qc.height * 0.5f) - (QrCode.img[imgno].height * qrratio * 0.5f) + y, (180 - counter) * 3.5f);
					
					qc.rotateX(PApplet.radians(counter * 2));
					qc.rotateY(PApplet.radians(counter * 2));
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2], (counter - 90) + 10);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(180 - counter != 0)
							qc.box(qrratio, qrratio, qrratio * 2 * (180 - counter) / 90.0f);
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix();
				}
			}
		}
		counter += 2;
		if(counter > 180){
			counter = 180;
			if(!run){
				run = true;
				firstf = true; // Ȉ
				qc.setRUNFIN(true);
			}
		}
	}
	
	private void draw4(){
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(box[i][j] && counter > 90){
					qc.pushMatrix();
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate((qc.width * 0.5f) - (QrCode.img[imgno].width * qrratio * 0.5f) + x,
							(qc.height * 0.5f) - (QrCode.img[imgno].height * qrratio * 0.5f) + y);
					
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2], (counter - 90) + 10);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(180 - counter != 0)
							qc.box(qrratio, qrratio, qrratio * 2 * (180 - counter) / 2.0f);
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix();
				}
			}
		}
		counter += 2;
		if(counter > 180){
			counter = 180;
			if(!run){
				run = true;
				firstf = true; // Ȉ
				qc.setRUNFIN(true);
			}
		}
	}
	
	private void findraw0(){
		int buff = (int)(((float)counter / (float)(qc.width * 5)) * 100);
		float z = ((float)(qc.width * 5 - counter) / ((float) qc.width * 2)) * distant;
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(box[i][j]){
					qc.pushMatrix();
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate((qc.width * 0.5f) - (QrCode.img[imgno].width * qrratio * 0.5f) + x,
							(qc.height * 0.5f) - (QrCode.img[imgno].height * qrratio * 0.5f) + y, z);
					
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2], buff);
					qc.rectMode(QrCode.CENTER);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(qc.width * 5 - counter != 0)
							qc.box(qrratio, qrratio, qrratio * 6 * z / (qc.width * 5 - counter));
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix();
				}
			}
		}
		counter-= 50;
		if(counter < 0){
			counter = 0;
			setMode(IDLE);
			qc.setFINFIN(true);
		}
	}
	
	private void findraw1(){
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(box[i][j]){
					qc.pushMatrix();
					qc.translate(qc.width*0.5f, qc.height*0.5f);
					qc.rotateX(PApplet.radians(counter - 180));
					qc.rotateY(PApplet.radians(counter - 180));
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate( - (QrCode.img[imgno].width * qrratio * 0.5f) + x,
							- (QrCode.img[imgno].height * qrratio * 0.5f) + y);
					
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2],  280 - counter);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(counter - 180 != 0)
							qc.box(qrratio, qrratio, qrratio * 2 * (counter - 180) / 180.0f);
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix();
				}
			}
		}
		counter += 4;
		if(counter > 270){
			counter = 0;
			setMode(IDLE);
			qc.setFINFIN(true);
		}
	}
	
	private void findraw2(){
		int buff = (int)(((float)counter / (float)(qc.width * 5)) * 100);
		float z = ((float)(qc.width * 5 - counter) / ((float) qc.width * 2)) * distant;
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(box[i][j]){
					qc.pushMatrix();
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate((qc.width * 0.5f) - (QrCode.img[imgno].width * qrratio * 0.5f) + x + z * (ROW % 2 * 2 - 1),
							(qc.height * 0.5f) - (QrCode.img[imgno].height * qrratio * 0.5f) + y + z * (COL % 2 * 2 - 1));
					
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2], buff);
					qc.rectMode(QrCode.CENTER);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(qc.width * 5 - counter != 0)
							qc.box(qrratio, qrratio, qrratio * z / (qc.width * 5 - counter));
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix();
				}
			}
		}
		counter-= 50;
		if(counter < 0){
			counter = 0;
			setMode(IDLE);
			qc.setFINFIN(true);
		}
	}
	
	private void findraw3(){
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(box[i][j]){
					qc.pushMatrix();
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate((qc.width * 0.5f) - (QrCode.img[imgno].width * qrratio * 0.5f) + x,
							(qc.height * 0.5f) - (QrCode.img[imgno].height * qrratio * 0.5f) + y, (counter + 180) * 3.5f);
					
					qc.rotateX(PApplet.radians((counter + 180) * 2));
					qc.rotateY(PApplet.radians((counter + 180) * 2));
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2], - counter - 80);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(counter + 180 != 0)
							qc.box(qrratio, qrratio, qrratio * 2 * (counter + 180) / 90.0f);
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix();
				}
			}
		}
		counter += 2;
		if(counter > - 90){
			counter = 0;
			setMode(IDLE);
			qc.setFINFIN(true);
		}
	}
	
	private void findraw4(){
		for(int i = 0; i < cellSize; i++){
			for(int j = 0; j < cellSize; j++){
				if(box[i][j]){
					qc.pushMatrix();
					int x = (COL * cellSize + i) * qrratio;
					int y = (ROW * cellSize + j) * qrratio;
					qc.translate((qc.width * 0.5f) - (QrCode.img[imgno].width * qrratio * 0.5f) + x,
							(qc.height * 0.5f) - (QrCode.img[imgno].height * qrratio * 0.5f) + y);
					
					qc.fill(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2], - counter - 80);
					if(!run){
						qc.stroke(QrCode.colors[imgno][0], QrCode.colors[imgno][1], QrCode.colors[imgno][2]);
						if(counter + 180 != 0)
							qc.box(qrratio, qrratio, qrratio * 2 * (counter + 180) / 2.0f);
						else
							qc.rect(0, 0, qrratio, qrratio);
					}else{
						qc.noStroke();
						qc.rect(0, 0, qrratio, qrratio);
					}
					qc.popMatrix();
				}
			}
		}
		counter += 2;
		if(counter > - 90){
			counter = 0;
			setMode(IDLE);
			qc.setFINFIN(true);
		}
	}
	
	public void setDistant(){
		distant = (int)(Math.random() * qc.height);
	}
	
	public void setMode(int MODE){
		this.MODE = MODE;
	}
	
	public void changeRatioListener(int qrratio){
		if(qrratio != (int)((qc.width / 1024.0f)) * 12){
			setQrRatio();
		}
	}
	
	public void setQrRatio(){
		qrratio = (int)((qc.width / 1024.0f) * 12);
	}
	
	public void fin(){
		
	}
}
